#include <shop>
#include <lvl_ranks>

public Plugin myinfo =
{
	name = "[Shop] Buy exp LvL",
	author = "Faya™ (DS: Faya™#8514)",
	version = "1.0",
	url = "http://hlmod.ru"
};

bool g_bLvL;
StringMap g_hExp;

public void OnPluginStart()
{
	if(Shop_IsStarted())
	{
		Shop_Started();
	}

	if(LR_IsLoaded())
	{
		LR_OnCoreIsReady();
	}
}

public void OnPluginEnd()
{
	Shop_UnregisterMe();
}

public void LR_OnCoreIsReady()
{
	g_bLvL = true;
}

public void Shop_Started()
{
	KeyValues Kv = new KeyValues("Settings");
	char szBuffer[PLATFORM_MAX_PATH];
	Shop_GetCfgFile(szBuffer, sizeof szBuffer, "exp_lvl.ini");

	if(FileToKeyValues(Kv, szBuffer))
	{
		delete g_hExp;
		g_hExp = new StringMap();

		CategoryId Category_id = Shop_RegisterCategory("ExpLvL", "Опыт лвл`а", "");

		if(Kv.GotoFirstSubKey())
		{
			do
			{
				if(Kv.GetSectionName(szBuffer, sizeof(szBuffer)) && Shop_StartItem(Category_id, szBuffer))
				{
					g_hExp.SetValue(szBuffer, Kv.GetNum("exp", 1));

					Shop_SetInfo(szBuffer, "", Kv.GetNum("price", 1000), -1, Item_BuyOnly);
					Shop_SetCallbacks(_, _, _, _, _, _, OnBuyExp);
					Shop_EndItem();
				}
			}
			while(Kv.GotoNextKey());
		}
	}
	else
	{
		SetFailState("Файл конфигурации не найден %s", szBuffer);
	}
}

bool OnBuyExp(int iClient, CategoryId category_id, const char[] category, ItemId item_id, const char[] item, ItemType type, int price, int sell_price, int value, int gold_price, int gold_sell_price)
{
	if(IsClientInGame(iClient))
	{
		if(g_bLvL)
		{
			g_hExp.GetValue(item, value);

			if(LR_ChangeClientValue(iClient, value))
			{
				PrintToChat(iClient, "[Shop] Вы купили %i опыта", value);

				RequestFrame(NextOpenShopMenu, GetClientUserId(iClient));
				return true;
			}
		}
		else
		{
			PrintToChat(iClient, "Ядро LvL`а не загружено");
		}
	}

	return false;
}

void NextOpenShopMenu(int iUserId)
{
	iUserId = GetClientOfUserId(iUserId);

	if(iUserId > 0)
	{
		Shop_OpenMainMenu(iUserId);
	}
}